/// charm : {"backCover":"","resources":[{"levelIcon":"","levelRange":"","levelSpecial":""}],"ribbon":""}
/// wealth : {"backCover":"","resources":[{"levelIcon":"","levelRange":"","levelSpecial":""}],"ribbon":""}

class SCLevelConfigRes {
  SCLevelConfigRes({
      Charm? charm,
      Wealth? wealth,}){
    _charm = charm;
    _wealth = wealth;
}

  SCLevelConfigRes.fromJson(dynamic json) {
    _charm = json['charm'] != null ? Charm.fromJson(json['charm']) : null;
    _wealth = json['wealth'] != null ? Wealth.fromJson(json['wealth']) : null;
  }
  Charm? _charm;
  Wealth? _wealth;
SCLevelConfigRes copyWith({  Charm? charm,
  Wealth? wealth,
}) => SCLevelConfigRes(  charm: charm ?? _charm,
  wealth: wealth ?? _wealth,
);
  Charm? get charm => _charm;
  Wealth? get wealth => _wealth;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    if (_charm != null) {
      map['charm'] = _charm?.toJson();
    }
    if (_wealth != null) {
      map['wealth'] = _wealth?.toJson();
    }
    return map;
  }

}

/// backCover : ""
/// resources : [{"levelIcon":"","levelRange":"","levelSpecial":""}]
/// ribbon : ""

class Wealth {
  Wealth({
      String? backCover,
      List<Resources>? resources,
      String? ribbon,}){
    _backCover = backCover;
    _resources = resources;
    _ribbon = ribbon;
}

  Wealth.fromJson(dynamic json) {
    _backCover = json['backCover'];
    if (json['resources'] != null) {
      _resources = [];
      json['resources'].forEach((v) {
        _resources?.add(Resources.fromJson(v));
      });
    }
    _ribbon = json['ribbon'];
  }
  String? _backCover;
  List<Resources>? _resources;
  String? _ribbon;
Wealth copyWith({  String? backCover,
  List<Resources>? resources,
  String? ribbon,
}) => Wealth(  backCover: backCover ?? _backCover,
  resources: resources ?? _resources,
  ribbon: ribbon ?? _ribbon,
);
  String? get backCover => _backCover;
  List<Resources>? get resources => _resources;
  String? get ribbon => _ribbon;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['backCover'] = _backCover;
    if (_resources != null) {
      map['resources'] = _resources?.map((v) => v.toJson()).toList();
    }
    map['ribbon'] = _ribbon;
    return map;
  }

}

/// levelIcon : ""
/// levelRange : ""
/// levelSpecial : ""

class Resources {
  Resources({
      String? levelIcon,
      String? levelRange,
      String? levelSpecial,}){
    _levelIcon = levelIcon;
    _levelRange = levelRange;
    _levelSpecial = levelSpecial;
}

  Resources.fromJson(dynamic json) {
    _levelIcon = json['levelIcon'];
    _levelRange = json['levelRange'];
    _levelSpecial = json['levelSpecial'];
  }
  String? _levelIcon;
  String? _levelRange;
  String? _levelSpecial;
Resources copyWith({  String? levelIcon,
  String? levelRange,
  String? levelSpecial,
}) => Resources(  levelIcon: levelIcon ?? _levelIcon,
  levelRange: levelRange ?? _levelRange,
  levelSpecial: levelSpecial ?? _levelSpecial,
);
  String? get levelIcon => _levelIcon;
  String? get levelRange => _levelRange;
  String? get levelSpecial => _levelSpecial;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['levelIcon'] = _levelIcon;
    map['levelRange'] = _levelRange;
    map['levelSpecial'] = _levelSpecial;
    return map;
  }

}

/// backCover : ""
/// resources : [{"levelIcon":"","levelRange":"","levelSpecial":""}]
/// ribbon : ""

class Charm {
  Charm({
      String? backCover,
      List<Resources>? resources,
      String? ribbon,}){
    _backCover = backCover;
    _resources = resources;
    _ribbon = ribbon;
}

  Charm.fromJson(dynamic json) {
    _backCover = json['backCover'];
    if (json['resources'] != null) {
      _resources = [];
      json['resources'].forEach((v) {
        _resources?.add(Resources.fromJson(v));
      });
    }
    _ribbon = json['ribbon'];
  }
  String? _backCover;
  List<Resources>? _resources;
  String? _ribbon;
Charm copyWith({  String? backCover,
  List<Resources>? resources,
  String? ribbon,
}) => Charm(  backCover: backCover ?? _backCover,
  resources: resources ?? _resources,
  ribbon: ribbon ?? _ribbon,
);
  String? get backCover => _backCover;
  List<Resources>? get resources => _resources;
  String? get ribbon => _ribbon;

  Map<String, dynamic> toJson() {
    final map = <String, dynamic>{};
    map['backCover'] = _backCover;
    if (_resources != null) {
      map['resources'] = _resources?.map((v) => v.toJson()).toList();
    }
    map['ribbon'] = _ribbon;
    return map;
  }

}
